#数据预处理：缺失数据和错误数据

##缺失数据的识别,可以发现绝大多数缺失值n=10207769
##而第一列绝大多数都是0，所以对现有数据进行相关性分析
#is.na(A_train)#判断是否存在缺失
n=sum(is.na(A_train))#输出缺失值个数
summary(A_train$UserInfo_4)   #39896个NA
length(A_train$UserInfo_4)

##数据备份与恢复
A_train_bak=A_train
#A_train=A_train_bak

fn.persent=function(data){
  persent=NULL
  for (i in 1:length(data)) {
    temp=data[,i]
    persent[i]=sum(is.na(temp))/length(temp)
  }
  plot(persent)
  return(persent)
}

persentAtr=fn.persent(A_train)
##统计缺失率，通过作图可以发现，缺失率很大，279个变量中，缺失率总体大于40%


#异常变量识别与处理
#作图发现，有1很多变量（196个）缺失值大于50%，填充也不太好，为此，不考虑这些数据的影响，删除这些数据。
tempAtr=which(persentAtr>0.39)
A_train2=A_train[,-tempAtr]
length(A_train2)
fn.persent(A_train2)

#######################################################################
##B_train数据处理,同理，删除缺失数据太多的变量
presentBtr=fn.persent(B_train)

tempBtr=which(presentBtr>0.65)
B_train2=B_train[,-tempBtr]
length(B_train2)
fn.persent(B_train2)

#######################################################################
##B_test数据处理,同理，删除缺失数据太多的变量
presentBte=fn.persent(B_test)
tempBte=which(presentBte>0.65)
B_test2=B_test[,-tempBte]
fn.persent(B_test2)




