#通过preMain.R得到如下值（persentAtr表示A_train缺失率向量/一维数组/变量；tempAtr表示缺失率大于阈值变量序号）：
#persentAtr
#presentBtr
#presentBte
#tempAtr
#tempBtr
#tempBte

#intersect集合求交集，即A_train,B_train共同通过阈值的变量
#tempABtr=intersect(tempBtr,tempAtr)
#tempB=intersect(tempBtr,tempBte)
#tempAB=intersect(tempABtr,tempBte)
#union集合并集
tempABtr=union(tempBtr,tempAtr)

#异常变量识别与处理
#很多变量缺失值很大，填充也不太好，为此，不考虑这些数据的影响，删除这些数据。
#去除A_train,B_train数据缺失太大的数据
A_train3=A_train[,-tempABtr]
B_train3=B_train[,-tempABtr]
length(A_train3)
fn.persent(A_train3)
length(B_train3)
fn.persent(B_train3)

#保存
#写结果
#write.csv(A_train3, "data/A_train3.csv", row.names = F, fileEncoding = "utf-8" )
#write.csv(B_train3, "data/B_train3.csv", row.names = F, fileEncoding = "utf-8" )


#缺失值处理
#缺失率这么高，如果直接删除缺失数据，会使得观测值急剧减少，就需要对缺失值进行填充。



#Hmisc包更加简单，可以插补均值、中位数等，你也可以插补指定值。
library(Hmisc)
#impute(newdata$Dream,mean)
#impute(newdata$Dream,median)
#impute(newdata$Dream,2)
A_train3[2]=impute(A_train3[2],mean)
for (i in 1:length(A_train3)) {
  A_train3[i]=impute(A_train3[i],mean)
}
for (i in 1:length(B_train3)) {
  B_train3[i]=impute(B_train3[i],mean)
}
##########################stop###############################

#多重插补法处理缺失。暂时未完成
library(lattice) #调入函数包
library(MASS)
library(nnet)
library(mice) #前三个包是mice的基础
#help(mice)
#library(VIM)

#显示缺失值
head(md.pattern(A_train3))


tmp1=md.pattern(A_train3)#缺失值0/1表示
fit=with(tmp1,lm(sales~date,data=A_train3))
pooled=pool(fit)
summary(pooled)
resultsA=complete(tmp1,action=3)

#m=5指的是插补数据集的数量 meth='pmm'指的使用预测均值匹配（Predictive mean matching ）作为插补方法。其他插补方法可以通过methods(mice)来查看。
imp=mice(A_train,m=3,maxit=50,meth='pmm',seed=500)#4重插补,即生成4个无缺失数据集/mice函数通过链式方程生成多元插补
result4=complete(imp,action=3) #选择第三个插补数据集作为结果

#查看插补效果
library(lattice)
xyplot(tempData,Ozone ~ Wind+Temp+Solar.R,pch=18,cex=1)

#整理得到训练集
#A_train_x=A_train[,-]
A_train_x=
  A_train_y=A_train$flag
write.csv(A_train, "data/pre_A_train.csv", row.names = F, fileEncoding = "utf-8" )

#######################################################################
##B_train数据处理,同理，删除缺失数据太多的变量
persentA=fn.persentA(B_train)
temp=which(persentA>0.75)
B_train2=B_train[,-temp]
length(B_train2)
persentA=fn.persentA(B_train2)
B_train3=B_train2$flag=1

#######################################################################
##B_test数据处理,同理，删除缺失数据太多的变量
persentA=fn.persentA(B_test)
temp=which(persentA>0.75)
B_test2=B_test[,-temp]
persentA=fn.persentA(B_test)


