#通过preMain.R得到如下值（persentAtr表示A_train缺失率向量/一维数组/变量；tempAtr表示缺失率大于阈值变量序号）：
#persentAtr
#presentBtr
#presentBte
#tempAtr
#tempBtr
#tempBte

#intersect集合求交集，即A_train,B_train共同通过阈值的变量
#tempABtr=intersect(tempBtr,tempAtr)
#tempB=intersect(tempBtr,tempBte)
#tempAB=intersect(tempABtr,tempBte)
#union集合并集
tempABtr=union(tempBtr,tempAtr)

#异常变量识别与处理
#很多变量缺失值很大，填充也不太好，为此，不考虑这些数据的影响，删除这些数据。
#去除A_train,B_train数据缺失太大的数据
A_train3=A_train[,-tempABtr]
B_train3=B_train[,-tempABtr]
length(A_train3)
fn.persent(A_train3)
length(B_train3)
fn.persent(B_train3)

#保存
#写结果
#write.csv(A_train3, "data/A_train3.csv", row.names = F, fileEncoding = "utf-8" )
#write.csv(B_train3, "data/B_train3.csv", row.names = F, fileEncoding = "utf-8" )


#缺失值处理
#缺失率这么高，如果直接删除缺失数据，会使得观测值急剧减少，就需要对缺失值进行填充。



#Hmisc包更加简单，可以插补均值、中位数等，你也可以插补指定值。
library(Hmisc)
#impute(newdata$Dream,mean)
#impute(newdata$Dream,median)
#impute(newdata$Dream,2)
A_train3[2]=impute(A_train3[2],mean)
for (i in 1:length(A_train3)) {
  A_train3[i]=impute(A_train3[i],mean)
}
for (i in 1:length(B_train3)) {
  B_train3[i]=impute(B_train3[i],mean)
}
##########################stop###############################